<template>
  <Loading v-if="$fetchState.pending && !$fetchState.error"></Loading>
  <Error v-else-if="$fetchState.error" :error="$fetchState.error"></Error>
  <div v-else>
    <ExploreBoard v-if="datasets.length" pretitle="explore" title="datasets">
      <template #header-right>
        <div class="btn-list justify-content-end">
          <div class="d-none d-sm-inline">
            <a
              class="btn mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible cursor-pointer"
              @click="initIntro()"
            >
              <DirectionsIcon />
              Step-by-step guide
            </a>
          </div>
          <div class="d-none d-sm-inline">
            <a
              href="/access-request/datasets"
              target="_blank"
              class="btn mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible"
            >
              <ScreenShareIcon />
              See Risis Datasets
            </a>
          </div>
          <a
            v-b-modal.modal-create-dataset
            href="#"
            class="btn btn-primary dataset-new d-none d-sm-inline-block"
          >
            <UploadIcon />
            Upload a dataset
          </a>
        </div>
      </template>
      <template #panel-left>
        <div class="nav-search-explore">
          <div class="mb-3">
            <div class="nav-search-explore-form">
              <div data-intro="This input allows you to search for datasets">
                <ExploreSearchBox
                  placeholder="Search in datasets…"
                  item-type="datasets"
                  :first="search.meta.first"
                  :last="search.meta.last"
                  :total="datasets.length"
                  @search="setSearchValue"
                >
                </ExploreSearchBox>
              </div>
            </div>
          </div>
          <ExploreSearchFilters
            :search-fields="searchFilter.fields"
            :sort-fields="searchFilter.sort"
            :defaults="searchFilter.defaults"
            direction="Descending"
            @filtersChanged="filtersChanged"
          />
        </div>
      </template>
      <template #main-content>
        <div
          v-if="filteredDatasets.length"
          class="rimow-card-deck row row-deck results-found"
        >
          <div
            v-for="dataset in filteredDatasets"
            :key="dataset.index"
            class="rimow-card card-sce col-sm-6 col-lg-4 mb-2"
          >
            <DatasetCard :dataset="dataset" />
          </div>
        </div>
        <EmptyData
          v-else
          title="No Dataset found"
          description="No Dataset found for your search"
          image="/illustrations/no-datasets-found.svg"
        >
        </EmptyData>
      </template>
    </ExploreBoard>
    <EmptyData
      v-else
      title="You don't have any datasets yet"
      description="Try creating a new one"
      image="/illustrations/no-datasets-found.svg"
    >
      <template #primary-button>
        <a
          v-b-modal.modal-create-dataset
          href="#"
          class="btn btn-primary project-new d-none d-sm-inline-block mb-5"
        >
          <FolderPlusIcon />
          Start a new dataset
        </a>
      </template>
    </EmptyData>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';

import searchFilterMixin from '~/mixins/search-filter.js';
export default {
  mixins: [searchFilterMixin],
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      filteredDatasets: [],
      filters: {
        filterBy: [{ filterBy: 'title' }],
        orderBy: "versions.'1.0.0'.date",
        direction: 'Descending',
      },
      valueToSearch: '',
      search: {
        meta: {
          first: 1,
          last: 0,
        },
      },
    };
  },
  async fetch() {
    await this.$nuxt.context.store.dispatch('datasets/fetchDatasets');
    this.filtersChanged(this.filters);
  },
  head() {
    return {
      title: 'Datasets - RISIS Workspace',
    };
  },
  computed: {
    ...mapGetters({
      datasets: 'datasets/allDatasets',
    }),
    searchFilter() {
      return {
        fields: [
          {
            text: 'Title',
            filterBy: 'title',
          },
          {
            text: 'Format',
            filterBy: 'format',
          },
          {
            text: 'Keywords',
            filterBy: 'keywords.value',
          },
          {
            text: 'Category',
            filterBy: 'category',
          },
          {
            text: 'Author',
            filterBy: "versions.'1.0.0'.authors_ids",
          },
          {
            text: 'Description',
            filterBy: 'short_description',
          },
        ],
        sort: [
          {
            text: 'Date',
            filterBy: "versions.'1.0.0'.date",
          },
          {
            text: 'Title',
            filterBy: 'title',
          },
          {
            text: 'Author',
            filterBy: "versions.'1.0.0'.authors_ids",
          },
        ],
      };
    },
  },
  watch: {
    datasets() {
      this.filtersChanged(this.filters);
    },
  },
  methods: {
    setSearchValue(valueToSearch) {
      this.valueToSearch = valueToSearch;
      this.filtersChanged(this.filters);
    },
    filtersChanged(filters) {
      this.filters = filters;
      this.filteredDatasets = this.searchFunction(
        this.valueToSearch,
        this.datasets,
        this.filters
      );
      this.filteredDatasets = this.applyFilter(
        this.filters,
        this.filteredDatasets
      );
      this.search.meta.last = this.filteredDatasets.length;
    },
    initIntro() {
      this.$store.commit('ui/showIntroJs');
    },
  },
};
</script>
